"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var AsyncEventEmitter = /** @class */ (function () {
    function AsyncEventEmitter() {
        this.listenerMap = new Map();
    }
    AsyncEventEmitter.prototype.OnceListenerWrapper = function (event, listener) {
        var _this = this;
        // @ts-ignore
        var _listener = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            _this.removeListener(event, _listener);
            return listener.apply(void 0, __spread(args));
        };
        return _listener;
    };
    AsyncEventEmitter.prototype.addListener = function (event, listener) {
        if (!this.listenerMap.has(event)) {
            this.listenerMap.set(event, []);
        }
        this.listenerMap.get(event).push(listener);
        return this;
    };
    AsyncEventEmitter.prototype.prependListener = function (event, listener) {
        if (!this.listenerMap.has(event)) {
            this.listenerMap.set(event, []);
        }
        this.listenerMap.get(event).unshift(listener);
        return this;
    };
    /**
     * @alias addListener
     */
    AsyncEventEmitter.prototype.on = function (event, listener) {
        return this.addListener(event, listener);
    };
    AsyncEventEmitter.prototype.once = function (event, listener) {
        return this.on(event, this.OnceListenerWrapper(event, listener));
    };
    AsyncEventEmitter.prototype.prependOnceListener = function (event, listener) {
        return this.prependListener(event, this.OnceListenerWrapper(event, listener));
    };
    AsyncEventEmitter.prototype.removeListener = function (event, listener) {
        var listeners = this.listenerMap.get(event);
        if (listeners && listeners.length > 0) {
            this.listenerMap.set(event, listeners.filter(function (cb) {
                return cb !== listener;
            }));
        }
        return this;
    };
    AsyncEventEmitter.prototype.removeAllListeners = function (event) {
        this.listenerMap.set(event, []);
        return this;
    };
    AsyncEventEmitter.prototype.listeners = function (event) {
        var _this = this;
        if (!event) {
            return __spread(this.listenerMap.keys()).map(function (e) { return _this.listeners(e); }).reduce(function (p, c) { return p.concat(c); }, []);
        }
        else {
            if (!this.listenerMap.has(event)) {
                return [];
            }
            else {
                return this.listenerMap.get(event);
            }
        }
    };
    AsyncEventEmitter.prototype.emit = function (event) {
        var _this = this;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var listeners = this.listenerMap.get(event);
        if (listeners && listeners.length > 0) {
            listeners.forEach(function (listener) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    listener.apply(void 0, __spread(args));
                    return [2 /*return*/];
                });
            }); });
            return true;
        }
        return false;
    };
    AsyncEventEmitter.prototype.emitAndGetReturnValue = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var returnValues, returnValues_1, returnValues_1_1, x;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.emitAndGetAllReturnValues.apply(this, __spread([event], args))];
                    case 1:
                        returnValues = _b.sent();
                        try {
                            for (returnValues_1 = __values(returnValues), returnValues_1_1 = returnValues_1.next(); !returnValues_1_1.done; returnValues_1_1 = returnValues_1.next()) {
                                x = returnValues_1_1.value;
                                if (typeof x !== "undefined") {
                                    return [2 /*return*/, x];
                                }
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (returnValues_1_1 && !returnValues_1_1.done && (_a = returnValues_1.return)) _a.call(returnValues_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    AsyncEventEmitter.prototype.emitAndGetAllReturnValues = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var listeners;
            var _this = this;
            return __generator(this, function (_a) {
                listeners = this.listenerMap.get(event);
                if (listeners && listeners.length > 0) {
                    return [2 /*return*/, Promise.all(listeners.map(function (listener) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                return [2 /*return*/, listener.apply(void 0, __spread(args))];
                            });
                        }); }))];
                }
                return [2 /*return*/];
            });
        });
    };
    AsyncEventEmitter.prototype.eventNames = function () {
        return __spread(this.listenerMap.keys());
    };
    return AsyncEventEmitter;
}());
exports.AsyncEventEmitter = AsyncEventEmitter;
exports.default = AsyncEventEmitter;
//# sourceMappingURL=async-event-emitter.js.map